/*******************************************************************************
*   Author       -  Kiraly Tibor
*                   http://www.tkiraaly.hu
*   Date         -  2016.05.06.
*   Chip         -  Atmel AMega8
*   Compiler     -  avr-gcc ( WinAVR)
*
*   AVR pin teszter (most konkretan ATmega8).
*   
*   A kivlasztott labat kimenetre allitja, es 0/1-be kapcsolgatja.
*   A labra ellenallason keresztul egy LED-et kotve ellenorizheto.
*   A soros vonalrol vezerelheto, nem figyeli, a megadott port/pin letezik-e,
*   ha nincs ilyen, nem fogja egyik labat sem kapcsolgatni.
*   A..K - a portot valasztja ki
*   0..7 - a bitet valasztja ki
*   
*******************************************************************************/
#define F_CPU                4 MHZ




#include "tkiraaly_atmega8.h"
#include "tkiraaly_kpin.c"
#include <util/delay.h>




volatile U8 pp=  0;                              // port/pin
volatile U8 c=   0;                              // vett betu



 
ISR( IT_USART_RXC)                               // USART megszakitas kezelese
{
   c= UDR;
   if ( c >= '0' && c <= '7') pp= ( pp & 0xF0)+ c- '0';
   if ( c >= 'A' && c <= 'K') pp= ( pp & 0x0F)+ (( c- 'A') << 4);
   if ( c >= 'a' && c <= 'k') pp= ( pp & 0x0F)+ (( c- 'a') << 4);
}




int main( void)
{
   U8 p;
   USART_9600_8N1;
   IT_ENABLE;
   for(;;)
   {
      p= pp;                                     // a ciklus elejen frissit 
      kpin_output( p);
      kpin_0( p);
      _delay_ms( 200);
      kpin_1( p);
      _delay_ms( 200);
      kpin_input( p);
   }
}
